<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { inject, type Ref } from 'vue'

const rail = inject<Ref<boolean>>('rail')
const drawer = inject<Ref<boolean>>('drawer')
const authStore = useAuthStore()
const role = authStore.getCurrentUser()!.role.name

const getUserAvatar = () => {
  const currentUser = authStore.getCurrentUser()
  if (currentUser && currentUser.image) {
    return `http://localhost:3000/images/users/${currentUser.image}`
  }

  return 'http://localhost:3000/images/users/noimage.jpg'
}
</script>

<template>
  <v-card>
    <v-navigation-drawer v-model="drawer" :rail="rail" permanent @click="rail = false" color="#FFF5E8" width="300">
      <template v-slot:prepend>
        <div v-if="!rail" class="text-center mt-3 mb-3">
          <!-- <v-avatar :prepend-avatar="getUserAvatar()" :title="authStore.getCurrentUser()?.name" size="100"
            @click.stop="rail = !rail">
            <v-img src="./img/logo/logo_brown.png"></v-img>
          </v-avatar>
          <br><br>
          <v-divider></v-divider> -->

          <v-avatar class="mt-5" rounded="100" size="80" @click.stop="rail = !rail">
            <v-img :src="getUserAvatar()" cover></v-img>
          </v-avatar>
          <v-list-item :title="authStore.getCurrentUser()?.name" :subtitle="authStore.getCurrentUser()!.role.name">
          </v-list-item>
        </div>
      </template>

      <v-divider></v-divider>

      <v-list width="310" density="compact" nav>
        <v-list-item prepend-icon="mdi-home" title="Main Menu" value="home" :to="{ name: 'home' }" active-class="border"
          class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-group>
            <template v-slot:activator="{ props }">
            <v-list-item v-bind="props" prepend-icon="mdi-store" title="POS"></v-list-item>
          </template>
          <v-list-item v-if="!rail" prepend-icon="mdi-store" title="Point of Sell" value="pos" :to="{ name: 'pos' }"
          active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-item v-if="!rail" prepend-icon="mdi-invoice" title="HistoryReceipt" value="historyReceipt"
            :to="{ name: 'historyReceipt' }" active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>

          </v-list-group>
        <v-list-item prepend-icon="mdi-clock" title="Check in / Check out" value="CheckIn-Out"
          :to="{ name: 'checkinout' }" active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>

        <v-list-group>
          <template v-slot:activator="{ props }">
            <v-list-item v-bind="props" prepend-icon="mdi-cash" title="Salary Management"></v-list-item>
          </template>
          <v-list-item prepend-icon="mdi-currency-usd" title="Salary payment" value="salaries"
            :to="{ name: 'salary' }" active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-item prepend-icon="mdi-receipt-text-clock" title="Payment History" value="payrollHistory"
            :to="{ name: 'payrollHistory' }" active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
        </v-list-group>

        <v-list-group>
          <template v-slot:activator="{ props }">
            <v-list-item v-bind="props" prepend-icon="mdi-cogs" title="Management"></v-list-item>
          </template>

          <v-list-item v-if="!rail && (role === 'เจ้าของกิจการ' || role === 'ผู้จัดการร้าน' || role === 'พนักงานพาทไทม์' || role === 'พนักงานทั่วไป')"
            prepend-icon="mdi-storefront-check" title="Stock Management" value="stock" :to="{ name: 'stock' }"
            active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-item v-if="!rail" prepend-icon="mdi-package-variant-closed" title="Material Management"
            value="material" :to="{ name: 'material' }" active-class="border" class="ml-0 my-3"
            :ripple="false"></v-list-item>
          <v-list-item v-if="!rail && (role === 'เจ้าของกิจการ' || role === 'ผู้จัดการร้าน')"
            prepend-icon="mdi-account-box-multiple" title="User Management" value="user" :to="{ name: 'user' }"
            active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-item v-if="!rail" prepend-icon="mdi-package" title="Product Management" value="product"
            :to="{ name: 'product' }" active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-item v-if="!rail && role === 'เจ้าของกิจการ' || role === 'ผู้จัดการร้าน'" prepend-icon="mdi-account"
            title="Member Management" value="member" :to="{ name: 'member' }" active-class="border" class="ml-0 my-3"
            :ripple="false"></v-list-item>
          <v-list-item v-if="!rail && role === 'เจ้าของกิจการ' || role === 'ผู้จัดการร้าน'"
            prepend-icon="mdi-awning-outline" title="Branch Management" value="branch" :to="{ name: 'branch' }"
            active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-item v-if="!rail" prepend-icon="mdi-information" title="Promotion Management" value="promotion"
            :to="{ name: 'promotion' }" active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
          <v-list-item v-if="!rail" prepend-icon="mdi-invoice" title="Utiliy" value="utiliycost"
            :to="{ name: 'utiliycost' }" active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
        </v-list-group>
        <v-list-item v-if="!rail" prepend-icon="mdi-information" title="Report" value="test" :to="{ name: 'ucreport' }"
          active-class="border" class="ml-0 my-3" :ripple="false"></v-list-item>
      </v-list>

      <v-divider></v-divider>

      <template v-slot:append>
        <div v-if="rail" class="pa-2 mt-2 mb-2">
          <v-btn title="Logout" value="logout" @click="authStore.logout()" active-class="border" class="ml-0 my-3"
            :ripple="false" block>
            <v-icon left>mdi-logout</v-icon>
          </v-btn>
        </div>

        <div v-if="!rail" class="pa-2 mt-2 mb-2">
          <v-btn prepend-icon="mdi-logout" title="Logout" value="logout" @click="authStore.logout()"
            active-class="border" class="ml-0 my-3" :ripple="false" block>
            Logout
          </v-btn>
        </div>
      </template>
    </v-navigation-drawer>
  </v-card>
</template>

<style scoped>
.border {
  background: #ffcb5e;
  border-top-left-radius: 30px;
  border-bottom-left-radius: 30px;
  text-decoration: none;
}

.border b:nth-child(1),
.border b:nth-child(2) {
  display: block;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 30px;
}
</style>
